Subject: IDE performance + atdisk2 patch
From: [email-masked] (David Monro)
Date: 8 Jul 1994 16:43:29 GMT
Newsgroups: comp.os.linux.announce

[ Moderator's note: 2000 line patch removed.  Please get it via ftp
  instead.  --liw ]

Ok, here it is. The complete patch to take a stock kernel to a kernel
capable of controlling 4 ide drives, all running with the performance
enhancing multimode patches.

It will (hopefully) be available from:
sunsite.unc.edu:/pub/Linux/kernel/patches/diskdrives/atdisk2-ide2.diff
and
tsx-11.mit.edu:/pub/linux/patches
and is attatched to the end of this article.

This is a combination of V2 of the IDE Performance package from Mark Lord
<[email-masked]> and the atdisk2 package from Delman Lee
<[email-masked]>, plus a little bit of judicious hacking from me to
get the ide performance hacks to apply to the hd1.c produced by the atdisk2
package.

Ther result has been running on my machine for a while, in fact since about
two days after IDE V2 was released (late April?). It has yet to cause me
any problems. However, I make no claims that it won't hose your system. In
fact:

 THE ABOVE LISTED AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS, IN NO EVENT SHALL THE ABOVE LISTED AUTHORS BE LIABLE FOR
 ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
 RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
 CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

OK?

The following patch was generated with respect to a _clean_ 1.1.23 kernel,
and patches cleanly for 1.1.24. It may not patch cleanly on anything before
1.1.22, but with a couple of tweaks it ought to work back to at least 1.1.9
and possibly right back to 1.0.0.

I suggest you get the atdisk2-0.9.tgz and linux-ideperf.patch packages
from sunsite.unc.edu:/pub/Linux/kernel/patches/diskdrives in order to read
the original readmes. This particularly applies to the atdisk package!

In the above directory you may also find the file atdisk-ideperf.patch.
Ignore this, as it is my merger of the atdisk9 and IDE V1.0 packages. This
supercedes it.

Thanks very much to Mark Lord for the IDE performance package,
and to Delman Lee for the atdisk2 package.

        David Monro

PS Currenty the drivers default to standard mode (ie no multi sector reads,
and no interrupt modifications. This patch should create
linux/drivers/block/README.hd, which tells you what to do with
linux/drivers/block/hdparm.c. Also, all sorts of interesting information
will be displayed by defining VERBOSE_DRIVE_INFO  1 near the top of both
hd.c and hd1.c. This will tell you which of your drives support how much
multimode, and a whole lot of other stuff. I would do this first time
around.

To apply:
cd /usr/src/linux		(or wherever your kernel sources are)
patch -p1 < atdisk2-ide2.diff	(redirect stdout/stderr to a file and check
					for errors)

--
Mail submissions for comp.os.linux.announce to: [email-masked]
PLEASE remember Keywords: and a short description of the software.